
#include <SPI.h> //include the SPI bus library
#include <MFRC522.h> //include the RFID reader library
#include <LiquidCrystal_I2C.h> //include the I2C display library
#include <Wire.h> //include the standard Arduino I2C library
LiquidCrystal_I2C myDisplay(0x27,16,2); //instantiate the LCD called "myDisplay", and set the LDC address, and tells the methods the display size
 
#define SS_PIN 10  //defines slave pin
#define RST_PIN 5  //defines reset pin
MFRC522 mfrc522(SS_PIN, RST_PIN); //instantiate a MFRC522 reader object       
MFRC522::MIFARE_Key key; //create a MIFARE_Key (named key) that hold card information


void setup() {
        pinMode(8,OUTPUT);
         
        myDisplay.init(); //initialized the LCD and I2C Bus                     
        myDisplay.backlight(); //turns on backlight
  
        Serial.begin(9600);        
        SPI.begin(); //initialize SPI Bus               
        mfrc522.PCD_Init(); //initialize MFRC522 card        
        myDisplay.println("Please Scan ID.."); //print to LCD
      
        for (byte i = 0; i < 6; i++) { 
                key.keyByte[i] = 0xFF; //defined in .h file (standard key from manufacturer)
        }
}
int block=2; //block number that is written into and read
byte blockcontent[16] = {"Access Granted."}; //an array with 16 bytes to be written into
byte readbackblock[18]; //a 18 byte array to read out a block

void loop()
{
        /*****************************************establishing contact with a tag/card**********************************************************************/

        //look for new cards
	if ( ! mfrc522.PICC_IsNewCardPresent()) { //if it returns 1, a new card has been found
		return; //if no new card is found, returns 0 and goes to start of loop
	}
        //select a card
	if ( ! mfrc522.PICC_ReadCardSerial()) { //if it returns 1, the uid struct from MFRC522.h contains the ID
		return; //if it returns 0, restart the loop
	} 
         /*****************************************writing and reading a block on the card**********************************************************************/
         
         writeBlock(block, blockcontent); //blockcontent array is written into the card block
         readBlock(block, readbackblock); // read the block back
       
         for (int j=0 ; j<16 ; j++) //print the block contents
         {
         Serial.write (readbackblock[j]); //translates the ASCII numbers and transmits to serial monitor
         }
         myDisplay.clear(); //clears LCD
         myDisplay.println("Access Granted.   "); //print to LCD
         delay(1000);

  
digitalWrite(8,HIGH); //turns on the DC motors
  delay(2500);
  digitalWrite(8,LOW); //turns off the DC motors
  delay(2000);  
  
}


